.686			
.MMX
.model flat, stdcall
option casemap:none

include p:\masm32\include\windows.inc
include p:\masm32\include\kernel32.inc
include p:\masm32\include\masm32.inc
include p:\masm32\include\msvcrt.inc

include p:\masm32\macros\macros.asm
include p:\masm32\macros\timers.asm

includelib p:\masm32\lib\kernel32.lib
includelib p:\masm32\lib\masm32.lib
includelib p:\masm32\lib\msvcrt.lib


Main        proto

BinSearch proto :DWORD,:DWORD,:DWORD,:DWORD,:DWORD
BInStr proto
BInStrWithLen proto
BMBinSearch proto :DWORD,:DWORD,:DWORD,:DWORD,:DWORD
BMBinSearch2 proto
FJT proto :DWORD,:DWORD,:DWORD,:DWORD
FJT2 proto
FJT3 proto
FJT4 proto

.data

align 4

  LOOP_COUNT    EQU	500000
  MINUS_1       EQU 0ffffffffH

  SzBS           db "BinSearch:        ",0
  SzBWL          db "BInStrWithLen:    ",0
  SzBMB          db "BMBinSearch:      ",0
  SzBM2          db "BMBinSearch2:     ",0
  SzBMC          db "FJT by Cresta:    ",0
  SzBMI          db "FJT2 Cresta/IanB: ",0
  SzBMI2         db "FJT3 Cresta/IanB: ",0
  SzBMI3         db "FJT4 Cresta/IanB: ",0

  ; very short source pattern to match data in

  ; matchlen 10, sourcelen 50
  ; with optimisations, the Boyer-Moore is now only half as slow as the
  ; word scanner for very short searches
  SzMatch1       db "Here it is"
  SzTest1        db "Short test with match string at end: Here it is!",13,10,0
  SzResult1      db 13,10,"Search Test 1 - value expected 37",13,10,0

  ; "Synthetic" source patterns to match data in

  ; matchlen 17, sourcelen 1024
  ; deliberately difficult, every position must be tested with this match start
  ; classic Boyer-Moore is definite loser, Cresta-style is definite winner on P4
  SzMatch2       db "MMMMMMhardMMMMMMM"
  SzTest2        db 1007 dup ("M"), "MMMMMMhardMMMMMMM", 0
  SzResult2      db 13,10,"Search Test 2 - value expected 1007",13,10,0

  ; matchlen 16, sourcelen 1024
  ; pattern very different from background, optimised Boyer-Moores really shine on P4
  SzMatch3       db "Should be easier"
  SzTest3        db 1008 dup ("M"), "Should be easier", 0
  SzResult3      db 13,10,"Search Test 3 - value expected 1008",13,10,0

  ; matchlen 16, sourcelen 1024
  ; longer match lengths with variations only at end suit classic Boyer-Moore perfectly
  SzMatch4       db "Many repetitions"
  SzTest4        db 72 dup ("Many repetitio"), "Many repetitions", 0
  SzResult4      db 13,10,"Search Test 4 - value expected 1008",13,10,0

  ; matchlen 16, sourcelen 1024
  ; opposite result, serious disadvantage for classic Boyer-Moore for this pattern
  ; as all the repeats must check from the matching end almost to the start
  SzMatch5       db "Many repetitions"
  SzTest5        db 72 dup ("No repetitions"), "Many repetitions", 0
  SzResult5      db 13,10,"Search Test 5 - value expected 1008",13,10,0

  ; short search pattern, normal text

  ; matchlen 3, sourcelen 1024
  ; Bug in original Cresta code shows failure, optimised version twice as fast as classic Boyer-Moore
  SzMatch6       db "iti"
  SzTest6        db 72 dup ("Many repeatsns"), "Many repetitions", 0
  SzResult6      db 13,10,"Search Test 6 - value expected 1018",13,10,0

  ; long search pattern, normal text

  ; matchlen 14, sourcelen 1024
  ; in more random text, the optimised Boyer-Moores are definite winners, Cresta's substantially so
  SzMatch7       db "no repetitions"
  SzTest7        db "The three algorithms are variations of a Boyer Moore design. "
                 db "The original design BMBinSearch is the most flexible across different search conditions. "
                 db "The two variations BMHBinsearch and SBMBinSearch are respectively a Horspool variation "
                 db "and a simplified variation which perform well depending on the hardware and the "
                 db "patterns being searched. The minimum pattern length is 2 bytes but these algorithms are "
                 db "slower on very short patterns than a classic byte scanner. The algorithms have about a "
                 db "300 character penalty at startup as they must construct a table so for either very "
                 db "short patterns or short data it is more efficient to use a byte scanner. "
                 db "The three algorithms are variations of a Boyer Moore design. "
                 db "The original design BMBinSearch is the most flexible across different search conditions. "
                 db "The two variations BMHBinsearch and SBMBinSearch are respectively a Horspool variation "
                 db "and a simplified variation which perform well depending on the hardware and the "
                 db "patterns being searched. Basic text, few or no repetitions", 0
  SzResult7      db 13,10,"Search Test 7 - value expected 1009",13,10,0

.data?

  ShiftTable     DWORD 256 DUP (?)

.code

Start:
	Invoke	Main
	Invoke	ExitProcess, 0


Main    proc

        push    ebx
        push    edi
        mov     eax, input("Please terminate any high-priority tasks and press ENTER to begin...")
        print   chr$(13,10,13,10,"String search tests:",13,10,13,10)

        ; test 1
        print   addr SzResult1

        print   addr SzBS
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
        invoke  BinSearch, 0, addr SzTest1, 50, addr SzMatch1, 10
        mov     edi, eax
        counter_end
        mov     ebx, eax
        print   ustr$(edi)
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10)
        invoke  Sleep, 250

        print   addr SzBMB
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
        invoke  BMBinSearch, 0, addr SzTest1, 50, addr SzMatch1, 10
        mov     edi, eax
        counter_end
        mov     ebx, eax
        print   ustr$(edi)
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10)
        invoke  Sleep, 250

        print   addr SzBM2
        push    ebp
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
        mov     eax, 10  ; matchlen
        mov     edx, 50  ; sourcelen
        lea     ecx, SzMatch1
        lea     ebp, SzTest1
        xor     ebx, ebx ; startpos
        invoke  BMBinSearch2
        mov     edi, eax
        counter_end
        pop     ebp
        mov     ebx, eax
        print   ustr$(edi)
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10)
        invoke  Sleep, 250

        print   addr SzBMC
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
        invoke  FJT, addr SzTest1, 50, addr SzMatch1, 10
        mov     edi, eax
        counter_end
        mov     ebx, eax
        print   ustr$(edi)
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10)
        invoke  Sleep, 250

        print   addr SzBMI
        push    ebp
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
        mov     eax, 10  ; matchlen
        mov     edx, 50  ; sourcelen
        lea     ecx, SzMatch1
        lea     ebp, SzTest1
        xor     ebx, ebx ; startpos
        invoke  FJT2
        mov     edi, eax
        counter_end
        pop     ebp
        mov     ebx, eax
        print   ustr$(edi)
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10)
        invoke  Sleep, 250

        print   addr SzBMI2
        push    ebp
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
        mov     eax, 10  ; matchlen
        mov     edx, 50  ; sourcelen
        lea     ecx, SzMatch1
        lea     ebp, SzTest1
        xor     ebx, ebx ; startpos
        invoke  FJT3
        mov     edi, eax
        counter_end
        pop     ebp
        mov     ebx, eax
        print   ustr$(edi)
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10)
        invoke  Sleep, 250

        print   addr SzBMI3
        push    ebp
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
        mov     eax, 10  ; matchlen
        mov     edx, 50  ; sourcelen
        lea     ecx, SzMatch1
        lea     ebp, SzTest1
        xor     ebx, ebx ; startpos
        invoke  FJT4
        mov     edi, eax
        counter_end
        pop     ebp
        mov     ebx, eax
        print   ustr$(edi)
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10)
        invoke  Sleep, 250


        ; test 2
        print   addr SzResult2

        print   addr SzBS
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
        invoke  BinSearch, 0, addr SzTest2, 1024, addr SzMatch2, 17
        mov     edi, eax
        counter_end
        mov     ebx, eax
        print   ustr$(edi)
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10)
        invoke  Sleep, 250

        print   addr SzBMB
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
        invoke  BMBinSearch, 0, addr SzTest2, 1024, addr SzMatch2, 17
        mov     edi, eax
        counter_end
        mov     ebx, eax
        print   ustr$(edi)
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10)
        invoke  Sleep, 250

        print   addr SzBM2
        push    ebp
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
        mov     eax, 17  ; matchlen
        mov     edx, 1024  ; sourcelen
        lea     ecx, SzMatch2
        lea     ebp, SzTest2
        xor     ebx, ebx ; startpos
        invoke  BMBinSearch2
        mov     edi, eax
        counter_end
        pop     ebp
        mov     ebx, eax
        print   ustr$(edi)
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10)
        invoke  Sleep, 250

        print   addr SzBMC
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
        invoke  FJT, addr SzTest2, 1024, addr SzMatch2, 17
        mov     edi, eax
        counter_end
        mov     ebx, eax
        print   ustr$(edi)
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10)
        invoke  Sleep, 250

        print   addr SzBMI
        push    ebp
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
        mov     eax, 17  ; matchlen
        mov     edx, 1024  ; sourcelen
        lea     ecx, SzMatch2
        lea     ebp, SzTest2
        xor     ebx, ebx ; startpos
        invoke  FJT2
        mov     edi, eax
        counter_end
        pop     ebp
        mov     ebx, eax
        print   ustr$(edi)
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10)
        invoke  Sleep, 250

        print   addr SzBMI2
        push    ebp
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
        mov     eax, 17  ; matchlen
        mov     edx, 1024  ; sourcelen
        lea     ecx, SzMatch2
        lea     ebp, SzTest2
        xor     ebx, ebx ; startpos
        invoke  FJT3
        mov     edi, eax
        counter_end
        pop     ebp
        mov     ebx, eax
        print   ustr$(edi)
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10)
        invoke  Sleep, 250

        print   addr SzBMI3
        push    ebp
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
        mov     eax, 17  ; matchlen
        mov     edx, 1024  ; sourcelen
        lea     ecx, SzMatch2
        lea     ebp, SzTest2
        xor     ebx, ebx ; startpos
        invoke  FJT4
        mov     edi, eax
        counter_end
        pop     ebp
        mov     ebx, eax
        print   ustr$(edi)
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10)
        invoke  Sleep, 250

        ; test 3
        print   addr SzResult3

        print   addr SzBS
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
        invoke  BinSearch, 0, addr SzTest3, 1024, addr SzMatch3, 16
        mov     edi, eax
        counter_end
        mov     ebx, eax
        print   ustr$(edi)
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10)
        invoke  Sleep, 250

        print   addr SzBMB
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
        invoke  BMBinSearch, 0, addr SzTest3, 1024, addr SzMatch3, 16
        mov     edi, eax
        counter_end
        mov     ebx, eax
        print   ustr$(edi)
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10)
        invoke  Sleep, 250

        print   addr SzBM2
        push    ebp
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
        mov     eax, 16  ; matchlen
        mov     edx, 1024  ; sourcelen
        lea     ecx, SzMatch3
        lea     ebp, SzTest3
        xor     ebx, ebx ; startpos
        invoke  BMBinSearch2
        mov     edi, eax
        counter_end
        pop     ebp
        mov     ebx, eax
        print   ustr$(edi)
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10)
        invoke  Sleep, 250

        print   addr SzBMC
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
        invoke  FJT, addr SzTest3, 1024, addr SzMatch3, 16
        mov     edi, eax
        counter_end
        mov     ebx, eax
        print   ustr$(edi)
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10)
        invoke  Sleep, 250

        print   addr SzBMI
        push    ebp
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
        mov     eax, 16  ; matchlen
        mov     edx, 1024  ; sourcelen
        lea     ecx, SzMatch3
        lea     ebp, SzTest3
        xor     ebx, ebx ; startpos
        invoke  FJT2
        mov     edi, eax
        counter_end
        pop     ebp
        mov     ebx, eax
        print   ustr$(edi)
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10)
        invoke  Sleep, 250

        print   addr SzBMI2
        push    ebp
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
        mov     eax, 16  ; matchlen
        mov     edx, 1024  ; sourcelen
        lea     ecx, SzMatch3
        lea     ebp, SzTest3
        xor     ebx, ebx ; startpos
        invoke  FJT3
        mov     edi, eax
        counter_end
        pop     ebp
        mov     ebx, eax
        print   ustr$(edi)
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10)
        invoke  Sleep, 250

        print   addr SzBMI3
        push    ebp
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
        mov     eax, 16  ; matchlen
        mov     edx, 1024  ; sourcelen
        lea     ecx, SzMatch3
        lea     ebp, SzTest3
        xor     ebx, ebx ; startpos
        invoke  FJT4
        mov     edi, eax
        counter_end
        pop     ebp
        mov     ebx, eax
        print   ustr$(edi)
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10)
        invoke  Sleep, 250

        ; test 4
        print   addr SzResult4

        print   addr SzBS
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
        invoke  BinSearch, 0, addr SzTest4, 1024, addr SzMatch4, 16
        mov     edi, eax
        counter_end
        mov     ebx, eax
        print   ustr$(edi)
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10)
        invoke  Sleep, 250

        print   addr SzBMB
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
        invoke  BMBinSearch, 0, addr SzTest4, 1024, addr SzMatch4, 16
        mov     edi, eax
        counter_end
        mov     ebx, eax
        print   ustr$(edi)
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10)
        invoke  Sleep, 250

        print   addr SzBM2
        push    ebp
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
        mov     eax, 16  ; matchlen
        mov     edx, 1024  ; sourcelen
        lea     ecx, SzMatch4
        lea     ebp, SzTest4
        xor     ebx, ebx ; startpos
        invoke  BMBinSearch2
        mov     edi, eax
        counter_end
        pop     ebp
        mov     ebx, eax
        print   ustr$(edi)
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10)
        invoke  Sleep, 250

        print   addr SzBMC
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
        invoke  FJT, addr SzTest4, 1024, addr SzMatch4, 16
        mov     edi, eax
        counter_end
        mov     ebx, eax
        print   ustr$(edi)
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10)
        invoke  Sleep, 250

        print   addr SzBMI
        push    ebp
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
        mov     eax, 16  ; matchlen
        mov     edx, 1024  ; sourcelen
        lea     ecx, SzMatch4
        lea     ebp, SzTest4
        xor     ebx, ebx ; startpos
        invoke  FJT2
        mov     edi, eax
        counter_end
        pop     ebp
        mov     ebx, eax
        print   ustr$(edi)
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10)
        invoke  Sleep, 250

        print   addr SzBMI2
        push    ebp
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
        mov     eax, 16  ; matchlen
        mov     edx, 1024  ; sourcelen
        lea     ecx, SzMatch4
        lea     ebp, SzTest4
        xor     ebx, ebx ; startpos
        invoke  FJT3
        mov     edi, eax
        counter_end
        pop     ebp
        mov     ebx, eax
        print   ustr$(edi)
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10)
        invoke  Sleep, 250

        print   addr SzBMI3
        push    ebp
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
        mov     eax, 16  ; matchlen
        mov     edx, 1024  ; sourcelen
        lea     ecx, SzMatch4
        lea     ebp, SzTest4
        xor     ebx, ebx ; startpos
        invoke  FJT4
        mov     edi, eax
        counter_end
        pop     ebp
        mov     ebx, eax
        print   ustr$(edi)
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10)
        invoke  Sleep, 250

        ; test 5
        print   addr SzResult5

        print   addr SzBS
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
        invoke  BinSearch, 0, addr SzTest5, 1024, addr SzMatch5, 16
        mov     edi, eax
        counter_end
        mov     ebx, eax
        print   ustr$(edi)
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10)
        invoke  Sleep, 250

        print   addr SzBMB
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
        invoke  BMBinSearch, 0, addr SzTest5, 1024, addr SzMatch5, 16
        mov     edi, eax
        counter_end
        mov     ebx, eax
        print   ustr$(edi)
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10)
        invoke  Sleep, 250

        print   addr SzBM2
        push    ebp
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
        mov     eax, 16  ; matchlen
        mov     edx, 1024  ; sourcelen
        lea     ecx, SzMatch5
        lea     ebp, SzTest5
        xor     ebx, ebx ; startpos
        invoke  BMBinSearch2
        mov     edi, eax
        counter_end
        pop     ebp
        mov     ebx, eax
        print   ustr$(edi)
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10)
        invoke  Sleep, 250

        print   addr SzBMC
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
        invoke  FJT, addr SzTest5, 1024, addr SzMatch5, 16
        mov     edi, eax
        counter_end
        mov     ebx, eax
        print   ustr$(edi)
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10)
        invoke  Sleep, 250

        print   addr SzBMI
        push    ebp
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
        mov     eax, 16  ; matchlen
        mov     edx, 1024  ; sourcelen
        lea     ecx, SzMatch5
        lea     ebp, SzTest5
        xor     ebx, ebx ; startpos
        invoke  FJT2
        mov     edi, eax
        counter_end
        pop     ebp
        mov     ebx, eax
        print   ustr$(edi)
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10)
        invoke  Sleep, 250

        print   addr SzBMI2
        push    ebp
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
        mov     eax, 16  ; matchlen
        mov     edx, 1024  ; sourcelen
        lea     ecx, SzMatch5
        lea     ebp, SzTest5
        xor     ebx, ebx ; startpos
        invoke  FJT3
        mov     edi, eax
        counter_end
        pop     ebp
        mov     ebx, eax
        print   ustr$(edi)
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10)
        invoke  Sleep, 250

        print   addr SzBMI3
        push    ebp
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
        mov     eax, 16  ; matchlen
        mov     edx, 1024  ; sourcelen
        lea     ecx, SzMatch5
        lea     ebp, SzTest5
        xor     ebx, ebx ; startpos
        invoke  FJT4
        mov     edi, eax
        counter_end
        pop     ebp
        mov     ebx, eax
        print   ustr$(edi)
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10)
        invoke  Sleep, 250

        ; test 6
        print   addr SzResult6

        print   addr SzBS
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
        invoke  BinSearch, 0, addr SzTest6, 1024, addr SzMatch6, 3
        mov     edi, eax
        counter_end
        mov     ebx, eax
        print   ustr$(edi)
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10)
        invoke  Sleep, 250

        print   addr SzBMB
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
        invoke  BMBinSearch, 0, addr SzTest6, 1024, addr SzMatch6, 3
        mov     edi, eax
        counter_end
        mov     ebx, eax
        print   ustr$(edi)
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10)
        invoke  Sleep, 250

        print   addr SzBM2
        push    ebp
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
        mov     eax, 3  ; matchlen
        mov     edx, 1024  ; sourcelen
        lea     ecx, SzMatch6
        lea     ebp, SzTest6
        xor     ebx, ebx ; startpos
        invoke  BMBinSearch2
        mov     edi, eax
        counter_end
        pop     ebp
        mov     ebx, eax
        print   ustr$(edi)
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10)
        invoke  Sleep, 250

        print   addr SzBMC
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
        invoke  FJT, addr SzTest6, 1024, addr SzMatch6, 3
        mov     edi, eax
        counter_end
        mov     ebx, eax
        print   ustr$(edi)
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10)
        invoke  Sleep, 250

        print   addr SzBMI
        push    ebp
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
        mov     eax, 3  ; matchlen
        mov     edx, 1024  ; sourcelen
        lea     ecx, SzMatch6
        lea     ebp, SzTest6
        xor     ebx, ebx ; startpos
        invoke  FJT2
        mov     edi, eax
        counter_end
        pop     ebp
        mov     ebx, eax
        print   ustr$(edi)
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10)
        invoke  Sleep, 250

        print   addr SzBMI2
        push    ebp
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
        mov     eax, 3  ; matchlen
        mov     edx, 1024  ; sourcelen
        lea     ecx, SzMatch6
        lea     ebp, SzTest6
        xor     ebx, ebx ; startpos
        invoke  FJT3
        mov     edi, eax
        counter_end
        pop     ebp
        mov     ebx, eax
        print   ustr$(edi)
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10)
        invoke  Sleep, 250

        print   addr SzBMI3
        push    ebp
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
        mov     eax, 3  ; matchlen
        mov     edx, 1024  ; sourcelen
        lea     ecx, SzMatch6
        lea     ebp, SzTest6
        xor     ebx, ebx ; startpos
        invoke  FJT4
        mov     edi, eax
        counter_end
        pop     ebp
        mov     ebx, eax
        print   ustr$(edi)
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10)
        invoke  Sleep, 250

        ; test 7
        print   addr SzResult7

        print   addr SzBS
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
        invoke  BinSearch, 0, addr SzTest7, 1024, addr SzMatch7, 14
        mov     edi, eax
        counter_end
        mov     ebx, eax
        print   ustr$(edi)
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10)
        invoke  Sleep, 250

        print   addr SzBMB
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
        invoke  BMBinSearch, 0, addr SzTest7, 1024, addr SzMatch7, 14
        mov     edi, eax
        counter_end
        mov     ebx, eax
        print   ustr$(edi)
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10)
        invoke  Sleep, 250

        print   addr SzBM2
        push    ebp
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
        mov     eax, 14  ; matchlen
        mov     edx, 1024  ; sourcelen
        lea     ecx, SzMatch7
        lea     ebp, SzTest7
        xor     ebx, ebx ; startpos
        invoke  BMBinSearch2
        mov     edi, eax
        counter_end
        pop     ebp
        mov     ebx, eax
        print   ustr$(edi)
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10)
        invoke  Sleep, 250

        print   addr SzBMC
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
        invoke  FJT, addr SzTest7, 1024, addr SzMatch7, 14
        mov     edi, eax
        counter_end
        mov     ebx, eax
        print   ustr$(edi)
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10)
        invoke  Sleep, 250

        print   addr SzBMI
        push    ebp
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
        mov     eax, 14  ; matchlen
        mov     edx, 1024  ; sourcelen
        lea     ecx, SzMatch7
        lea     ebp, SzTest7
        xor     ebx, ebx ; startpos
        invoke  FJT2
        mov     edi, eax
        counter_end
        pop     ebp
        mov     ebx, eax
        print   ustr$(edi)
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10)
        invoke  Sleep, 250

        print   addr SzBMI2
        push    ebp
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
        mov     eax, 14  ; matchlen
        mov     edx, 1024  ; sourcelen
        lea     ecx, SzMatch7
        lea     ebp, SzTest7
        xor     ebx, ebx ; startpos
        invoke  FJT3
        mov     edi, eax
        counter_end
        pop     ebp
        mov     ebx, eax
        print   ustr$(edi)
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10)
        invoke  Sleep, 250

        print   addr SzBMI3
        push    ebp
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
        mov     eax, 14  ; matchlen
        mov     edx, 1024  ; sourcelen
        lea     ecx, SzMatch7
        lea     ebp, SzTest7
        xor     ebx, ebx ; startpos
        invoke  FJT4
        mov     edi, eax
        counter_end
        pop     ebp
        mov     ebx, eax
        print   ustr$(edi)
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10,13,10)
        invoke  Sleep, 250

        mov     eax, input(" Press ENTER to exit...")
        pop     edi
        pop     ebx
        ret

Main	EndP

; ------------------------------------------------------------------------------

Align 16

BinSearch proc startpos:DWORD,lpSource:DWORD,sLen:DWORD,lpPattern:DWORD,pLen:DWORD

    push ebx
    push esi
    push edi

  ; ----------------
  ; setup loop code
  ; ----------------
    mov esi, lpSource
    mov edi, lpPattern
    mov al, [edi]           ; get 1st char in pattern

    mov ecx, sLen
    sub ecx, pLen           ; sub pattern len to avoid searching past end of src
    add ecx, 1
    add esi, ecx            ; add source length
    neg ecx                 ; invert sign
    add ecx, startpos       ; add starting offset
    sub pLen, 1
    jmp Scan_Loop

  ; ----------------------------------------

  align 4
  Pre_Match:
    lea ebx, [esi+ecx]      ; put current scan address in EBX
    mov edx, pLen           ; put pattern length into EDX

  Test_Match:
    mov ah, [ebx+edx-1]     ; load last byte of pattern length in main string
    cmp ah, [edi+edx-1]     ; compare it with last byte in pattern
    jne Pre_Scan            ; exit loop on mismatch
    sub edx, 1
    jnz Test_Match

    jmp Match

  align 4
  Pre_Scan:
    add ecx, 1              ; start on next byte

  Scan_Loop:
    cmp al, [esi+ecx]       ; scan for 1st byte of pattern
    je Pre_Match            ; test if it matches
    add ecx, 1
    js Scan_Loop            ; exit on sign inversion

  ; ----------------------------------------
    
  No_Match:                 ; fall through here on no match
    mov eax, -1
    jmp isOut

  Match:
    add ecx, sLen
    sub ecx, pLen
    mov eax, ecx

  isOut:
    pop edi
    pop esi
    pop ebx

    ret

BinSearch endp

; ------------------------------------------------------------------------------

Align 16

BMBinSearch proc startpos:DWORD,
                 lpSource:DWORD,srcLngth:DWORD,
                 lpSubStr:DWORD,subLngth:DWORD

  ; -----------------------------------------------------------------
  ; This version uses four heuristics, it determines the shift type
  ; from the character in the table, if the character is not in the
  ; pattern, it performs a BAD CHARACTER shift, if the character is
  ; in the pattern, it determines if it is the first comparison after
  ; the shift and adds the GOOD SUFFIX shift to the location counter.
  ; If the comparison is not the first after the shift, it calculates
  ; the GOOD SUFFIX shift and adds it to the location counter.
  ; -----------------------------------------------------------------

    LOCAL cval   :DWORD
    LOCAL shift_table[256]:DWORD

    push ebx
    push esi
    push edi

    mov ebx, subLngth

    cmp ebx, 1
    jg @F
    mov eax, -2                 ; string too short, must be > 1
    jmp Cleanup
  @@:

    mov esi, lpSource
    add esi, srcLngth
    sub esi, ebx
    mov edx, esi            ; set Exit Length

  ; ----------------------------------------
  ; load shift table with value in subLngth
  ; ----------------------------------------
    mov ecx, 256
    mov eax, ebx
    lea edi, shift_table
    rep stosd

  ; ----------------------------------------------
  ; load decending count values into shift table
  ; ----------------------------------------------
    mov ecx, ebx                ; SubString length in ECX
    dec ecx                     ; correct for zero based index
    mov esi, lpSubStr           ; address of SubString in ESI
    lea edi, shift_table

    xor eax, eax

  Write_Shift_Chars:
    mov al, [esi]               ; get the character
    inc esi
    mov [edi+eax*4], ecx        ; write shift for each character
    dec ecx                     ; to ascii location in table
    jnz Write_Shift_Chars

  ; -----------------------------
  ; set up for main compare loop
  ; -----------------------------
    mov ecx, ebx
    dec ecx
    mov cval, ecx

    mov esi, lpSource
    mov edi, lpSubStr
    add esi, startpos           ; add starting position

    jmp Pre_Loop

; %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

  Calc_Suffix_Shift:
    add eax, ecx
    sub eax, cval               ; sub loop count
    jns Add_Suffix_Shift
    mov eax, 1                  ; minimum shift is 1

  Add_Suffix_Shift:
    add esi, eax                ; add SUFFIX shift
    mov ecx, cval               ; reset counter in compare loop

  Test_Length:
    cmp edx, esi                ; test exit condition
    jl No_Match

  Pre_Loop:
    xor eax, eax                ; zero EAX for following partial writes
    mov al, [esi+ecx]
    cmp al, [edi+ecx]           ; cmp characters in ESI / EDI
    je @F
    mov eax, shift_table[eax*4]
    cmp ebx, eax
    jne Add_Suffix_Shift        ; bypass SUFFIX calculations
    lea esi, [esi+ecx+1]        ; add BAD CHAR shift
    jmp Test_Length
  @@:
    dec ecx
    xor eax, eax                ; zero EAX for following partial writes

  Cmp_Loop:
    mov al, [esi+ecx]
    cmp al, [edi+ecx]           ; cmp characters in ESI / EDI
    jne Set_Shift               ; if not equal, get next shift
    dec ecx
    jns Cmp_Loop
    jmp Match                   ; fall through on match

  Set_Shift:
    mov eax, shift_table[eax*4]
    cmp ebx, eax
    jne Calc_Suffix_Shift       ; run SUFFIX calculations
    lea esi, [esi+ecx+1]        ; add BAD CHAR shift
    jmp Test_Length

; %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

  Match:
    sub esi, lpSource           ; sub source from ESI
    mov eax, esi                ; put length in eax
    jmp Cleanup

  No_Match:
    mov eax, -1

  Cleanup:
    pop edi
    pop esi
    pop ebx

    ret

BMBinSearch endp

; ------------------------------------------------------------------------------

Align 16

OPTION PROLOGUE:none
OPTION EPILOGUE:none

BMBinSearch2 proc

 comment    * -----------------------------------------------------------------------------
            BMBinSearch rewritten by IanB to use the same entry and exit protocols as
            BInStrWithLen, plus a general tune-up improving speed by up to 25%, including
            the use of the .DATA? section for the ShiftTable, as using a stack-based table
            almost wiped out the speed gains in my testing. Also restricted search string
            to 256 chars, allowing byte-length shifts and a 256-byte shift table.

            On entry:
                EAX = length of StrToFind (must be >= 2 and < 256)
                ECX = pointer to StrToFind
                EDX = SourceLen
                EBP = SourceArray
                EBX = StartPos
            On exit:
                EAX = string position (from start of SourceArray) or -1 if not found
                EDX = length of StrToFind
            EBX/EBP/EDI/ESI are preserved.
            ----------------------------------------------------------------------------- *

    push esi
    push edi
    push eax
    push ebx

    cmp eax, 2              ; string too short, must be > 1
    jb  Bad_Param
    cmp eax, 255            ; string too long, must be < 256
    ja  Bad_Param

    push ebp
    add edx, ebp
    mov esi, ecx            ; address of SubString in ESI
    add ebp, ebx            ; add starting position
    sub edx, eax            ; set Exit Length

  ; ----------------------------------------
  ; load shift table with value in subLngth
  ; ----------------------------------------
    lea edi, ShiftTable
    mov ecx, 256
    rep stosb

  ; ----------------------------------------------
  ; load decending count values into shift table
  ; ----------------------------------------------
    mov ebx, eax                ; SubString length in EBX
    mov edi, esi
    sub eax, 1                  ; correct for zero based index

  Write_Shift_Chars:
    movzx ecx, BYTE PTR [edi]   ; get the character
    add edi, 1
    mov BYTE PTR ShiftTable[ecx], al     ; write shift for each character
    sub al, 1                   ; to ascii location in table
    jnz Write_Shift_Chars

  ; -----------------------------
  ; set up for main compare loop
  ; -----------------------------
    movzx ecx, BYTE PTR [ebp+ebx-1]
    lea edi, [ebx-1]
    add eax, ebp                ; this register is basis for output value
    jmp Pre_Loop

; %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

  Calc_Suffix_Shift:
    add ecx, ebp
    sub ecx, ebx                ; sub loop count
    jbe Set_Minimum_Shift

  Add_Suffix_Shift:
    sub edi, ebp                ; EDI = -1
    add eax, ecx                ; add SUFFIX shift
    add edi, ebx                ; reset counter in compare loop

  Test_Length:
    movzx ecx, BYTE PTR [eax+edi]
    cmp eax, edx                ; test exit condition
    ja No_Match

  Pre_Loop:
    cmp cl, [esi+edi]           ; cmp characters in EAX / ESI
    je @F
    movzx ecx, BYTE PTR ShiftTable[ecx]
    lea ebp, [edi+1]
    cmp ebx, ecx
    jne Add_Suffix_Shift        ; bypass SUFFIX calculations
    add eax, ebp                ; add BAD CHAR shift
    jmp Test_Length

  Cmp_Loop:
    cmp cl, [esi+edi]           ; cmp characters in EAX / ESI
    jne Set_Shift               ; if not equal, get next shift
  @@:
    movzx ecx, BYTE PTR [eax+edi-1]
    sub edi, 1
    jns Cmp_Loop
    jmp Match                   ; fall through on match

  Set_Shift:
    movzx ecx, BYTE PTR ShiftTable[ecx]
    lea ebp, [edi+1]
    cmp ebx, ecx
    jne Calc_Suffix_Shift       ; run SUFFIX calculations
    add eax, ebp                ; add BAD CHAR shift
    jmp Test_Length

  Set_Minimum_Shift:
    mov ecx, 1                  ; minimum shift is 1
    jmp Add_Suffix_Shift

; %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

  Match:
    pop ebp
    sub eax, ebp                ; put length in eax
    jmp Cleanup

  No_Match:
    pop ebp

  Bad_Param:
    or  eax, MINUS_1

  Cleanup:
    pop ebx
    pop edx
    pop edi
    pop esi

    ret

BMBinSearch2 endp


; ------------------------------------------------------------------------------

align 16

;============ * BM by Cresta * =====================

FJT	proc	lpData:DWORD, DataLen:DWORD, lpMatch:DWORD, match_len:DWORD

	push	ebx
	push	ebp
	push	esi
	push	edi
	sub	esp,1024                    	;LOCAL forward_tbl[256]          :DWORD
    
	mov	ecx,256
	mov	edx,dword ptr [esp+1056]    	;match_len
	inc	edx
	dec	ecx
   
fill:  						;--  < d+1>   256 d 
	mov	[esp+ecx*4],edx
	dec	ecx
	jns	fill
    
	dec	edx				;edx=match_len
	xor	ecx,ecx
	mov	edi,dword ptr [esp+1052]	;lpMatch

put_offset:		;--    a ,  d   esi
	movzx	eax, byte ptr[edi+ecx]	;  d d
	mov	[esp+eax*4],edx             	; a      ya 
	sub	dword ptr[esp+eax*4],ecx	; + < d>
	inc	ecx
	cmp	ecx,edx
	jne	put_offset
end_put:                        ;   :
                                    ; 16-   esi (esi+16)  o  d,
                                    ;   +17
                                    ; 16-   esi (esi+16) o  d
                                    ;   0 - . = +16 (add esi,16)
                                    ;   1 - . = +15 (add esi,15)
                                    ;...................................
                                    ;  14 - . =  +2 (add esi,2)
                                    ;  15 - . =  +1 (add esi,1)
    
	mov	esi,dword ptr [esp+1044]    	;esi=lpData
	mov	ebx,esi
	add	ebx,dword ptr [esp+1048]    	;ebx=lpData+DataLen
	sub	ebx,edx                     	;ebx=lpData+DataLen-match_len
	inc	ebx                         	;d d,  da 
    
	mov	ebp,edx                     	;dword ptr [esp+1056]=match_len
        
scan: 
	mov	edx,ebp                     	;edx = <bytes's count>
	shr	edx,2                       	;edx = <dword's count>
	dec	edx                         	;edx = <dword's count - 1>
	mov	ecx,edx                     	;ecx = <dword's count - 1>
align 4    
first_dword:                       			; d
	mov	eax,[esi]                   	;d d
	cmp	eax,[edi]                   	;  - d d
	jne	@F                          	;  a
align 4
scan_dword:
	mov	eax,[esi+edx*4]             	;dd  d esi...esi+match_len     
	cmp	eax,[edi+edx*4]             	;d  
	jne	@F                          	;   - d   d
	dec	edx                         	;     1 d
	js	last_bytes                   	;   a - do  dd oo 
	mov	eax,[esi+edx*4]             	;    a, d
	cmp	eax,[edi+edx*4]
	jne	@F
	dec	edx
	js	last_bytes
	mov	eax,[esi+edx*4]
	cmp	eax,[edi+edx*4]
	jne	@F
	dec	edx
	js	last_bytes
	mov	eax,[esi+edx*4]
	cmp	eax,[edi+edx*4]
	jne	@F
	dec	edx
	js	last_bytes
	jmp	scan_dword
align 4 
 @@:                                		; do  esi...esi+match_len d _ d
	movzx	eax, byte ptr[esi+ebp]	;d  esi+match_len     a o  d
	add	esi,[esp+eax*4]             	; o_ ya  ddd esi
	cmp	esi,ebx                     	;  dd esi  d d d,
	mov	edx,ecx                     	;  edx  ecx - o d
	jle	first_dword                 	;d   esi  d_.

  ;--   .
no_match:
	or	eax,-1
	jmp	@Ret
last_bytes:                         				;  d   esi   d
	inc	ecx                         	;ecx - - d  d
	mov	edx,dword ptr [esp+1056]    	;edx -  d  o
	shl	ecx,2                       	;ecx -  ddo 
	sub	edx,ecx                     	;edx - - , oo dd (0...3)
	add	esi,ecx                     	;a esi  edi  o dd
	add	edi,ecx                     	; d  a esi.
 @@:
	dec	edx                         	;dd oo  
	js	found                        	; dd  -  o
	mov	al,byte ptr[esi+edx]
	cmp	byte ptr[edi+edx],al
	je	@B
	sub	esi,ecx			; ,    o   
	sub	edi,ecx			; esi  edi     d
	inc	esi				;a   1 
	jmp	scan				;d .
    
found:                             		 		;   d  .
	sub	esi,ecx
	mov	eax,esi
	sub	eax,dword ptr [esp+1044]    	;lpData
@Ret:
	add	esp,1024
	pop	edi
	pop	esi
	pop	ebp
	pop	ebx
	retn	16                         	;return file offset of substring or -1 if not found

FJT endp

; ------------------------------------------------------------------------------

align 16

FJT2	proc

 comment    * -----------------------------------------------------------------------------
            BM by Cresta rewritten by IanB to use the same entry and exit protocols as
            BInStrWithLen, optimisations including the use of the .DATA? section for the
            ShiftTable, as the extra indexing is slower. Bugfix for less than 4 search
            chars. Search string restricted to 255 chars, allowing byte-length shifts and
            a 256-byte shift table only.

            On entry:
                EAX = match_len (must be >= 2 and < 255)
                ECX = lpMatch, pointer to test string
                EDX = DataLen
                EBP = lpData, pointer to source array
                EBX = StartPos offset in lpData
            On exit:
                EAX = string position (from start of source array) or -1 if not found
                EDX = match_len
            EBX/EBP/EDI/ESI are preserved.
            ----------------------------------------------------------------------------- *

        push    esi
        push    edi
        push    eax
        push    ebx
        push    ebp

        cmp     eax, 2                  ; string too short, must be > 1
        jb      no_match
        cmp     eax, 254                ; string too long, must be < 254
        ja      no_match

        add	    edx, ebp
        add     ebp, ebx                ; EBP = lpData (including startpos offset if any)
        lea     edi, ShiftTable
        mov     ebx, eax                ; EBX = match_len
        sub	    edx, eax
        add     eax, 1
        mov     esi, ecx                ; ESI = lpMatch
        mov     ah, al                  ; copy value
        add     edx, 1                  ; EDX = lpData+DataLen-match_len+1
        mov     ecx, 128
        rep     stosw                   ; fill 256-byte ShiftTable with match_len+1

        mov     edi, ebp                ; EDI = lpData + startpos
        mov     ebp, esi
        sub     eax, 1                  ; EAX = match_len

align 16

put_offset:
        movzx   ecx, BYTE PTR [ebp]
        add     ebp, 1
        mov     BYTE PTR ShiftTable[ecx], al
        sub     al, 1
        jnz     put_offset

        mov     ebp, ebx                ; EBP = match_len
        mov     eax, [esi]              ; get first DWORD to compare
        cmp     ebx, 4
        jb      less_than_dword

align 16

first_dword:
        movzx   ecx, BYTE PTR [edi+ebp]
        and     ebx, 0fffffffcH         ; remove remainder bytes over DWORD count
        cmp     eax, [edi]
        movzx   ecx, BYTE PTR ShiftTable[ecx]    ; doesn't change flags
        je      start_matched
        jmp     do_shift

align 16

restart_loop:
        mov     eax, [esi]              ; get first DWORD to compare

do_shift:
        add     edi, ecx
        mov     ebx, ebp                ; restore match_len
        cmp     edi, edx                ; check for end of data
        jle     first_dword

no_match:
        or      eax, MINUS_1
        pop     ebp
        jmp     @Ret

align 16

scan_dwords:
        mov     eax, [esi+ebx]
        cmp     eax, [edi+ebx]
        jne     restart_loop
        sub     ebx, 4
        jz      last_bytes

        mov     eax, [esi+ebx]
        cmp     eax, [edi+ebx]
        jne     restart_loop
        sub     ebx, 4
        jz      last_bytes

        mov     eax, [esi+ebx]
        cmp     eax, [edi+ebx]
        jne     restart_loop
        sub     ebx, 4
        jz      last_bytes

        mov     eax, [esi+ebx]
        cmp     eax, [edi+ebx]
        jne     restart_loop

start_matched:
        sub     ebx, 4
        jz      last_bytes
        jmp     scan_dwords

align 16

less_than_dword:
        mov     ebx, eax
        sub     ebp, 2                  ; processing either 2 or 3 bytes
        shr     ebx, 16

align 16

@@:
        movzx   ecx, BYTE PTR [edi+ebp+2]
        cmp     ax, WORD PTR [edi]
        movzx   ecx, BYTE PTR ShiftTable[ecx]    ; doesn't change flags
        je      matched_word

shift_word:
        add     edi, ecx
        cmp     edi, edx                ; check for end of data
        jle     @B
        jmp     no_match

align 16

matched_word:
        test    ebp, ebp
        jz      found
        cmp     bl, BYTE PTR [edi+2]
        je      found
        jmp     shift_word

align 16

last_bytes:
        mov     ebx, 0fffffffcH
        test    ebp, 3H                 ; are there any remainder bytes to test
        jz      found

        and     ebx, ebp
        mov     eax, [esi+ebx]
        mov     ebx, [edi+ebx]
        test    ebp, 2H
        jz      single_byte

        cmp     ax, bx
        jne     restart_loop
        test    ebp, 1H
        jz      found
        and     eax, 0ff0000H
        and     ebx, 0ff0000H
        sub     eax, ebx
        jne     restart_loop
        jmp     found

single_byte:
        sub     al, bl
        jne     restart_loop
    
align 16

found:
        pop     ebp
        mov     eax, edi
        sub     eax, ebp
@Ret:
        pop     ebx
        pop     edx                     ; return match_len in EDX
        pop     edi
        pop     esi
        ret                             ; return offset of string or -1 if not found

FJT2 endp

; ------------------------------------------------------------------------------

align 16

FJT3	proc

 comment    * -----------------------------------------------------------------------------
            BM by Cresta rewritten by IanB to use the same entry and exit protocols as
            BInStrWithLen, optimisations including the use of the .DATA? section for the
            ShiftTable, as the extra indexing is slower. Bugfix for less than 4 search
            chars. Search string restricted to 64K-1 chars, allowing word-length shifts and
            a 256-word shift table only.

            On entry:
                EAX = match_len (must be >= 2 and < 65535)
                ECX = lpMatch, pointer to test string
                EDX = DataLen
                EBP = lpData, pointer to source array
                EBX = StartPos offset in lpData
            On exit:
                EAX = string position (from start of source array) or -1 if not found
                EDX = match_len
            EBX/EBP/EDI/ESI are preserved.
            ----------------------------------------------------------------------------- *

        push    esi
        push    edi
        push    eax
        push    ebx
        push    ebp

        cmp     eax, 2                  ; string too short, must be > 1
        jb      no_match
        cmp     eax, 65534              ; string too long, must be < 65535
        ja      no_match

        add	    edx, ebp
        add     ebp, ebx                ; EBP = lpData (including startpos offset if any)
        lea     edi, ShiftTable
        mov     ebx, eax                ; EBX = match_len
        sub	    edx, eax
        add     eax, 1
        mov     esi, ecx                ; ESI = lpMatch
        add     edx, 1                  ; EDX = lpData+DataLen-match_len+1
        mov     ecx, 256
        rep     stosw                   ; fill 256-WORD ShiftTable with match_len+1

        mov     edi, ebp                ; EDI = lpData + startpos
        mov     ebp, esi
        sub     eax, 1                  ; EAX = match_len

align 16

put_offset:
        movzx   ecx, BYTE PTR [ebp]
        add     ebp, 1
        mov     WORD PTR ShiftTable[ecx+ecx], ax
        sub     ax, 1
        jnz     put_offset

        mov     ebp, ebx                ; EBP = match_len
        mov     eax, [esi]              ; get first DWORD to compare
        cmp     ebx, 4
        jb      less_than_dword

align 16

first_dword:
        movzx   ecx, BYTE PTR [edi+ebp]
        and     ebx, 0fffffffcH         ; remove remainder bytes over DWORD count
        cmp     eax, [edi]
        movzx   ecx, WORD PTR ShiftTable[ecx+ecx]    ; doesn't change flags
        je      start_matched
        jmp     do_shift

align 16

restart_loop:
        mov     eax, [esi]              ; get first DWORD to compare

do_shift:
        add     edi, ecx
        mov     ebx, ebp                ; restore match_len
        cmp     edi, edx                ; check for end of data
        jle     first_dword

no_match:
        or      eax, MINUS_1
        pop     ebp
        jmp     @Ret

align 16

scan_dwords:
        mov     eax, [esi+ebx]
        cmp     eax, [edi+ebx]
        jne     restart_loop
        sub     ebx, 4
        jz      last_bytes

        mov     eax, [esi+ebx]
        cmp     eax, [edi+ebx]
        jne     restart_loop
        sub     ebx, 4
        jz      last_bytes

        mov     eax, [esi+ebx]
        cmp     eax, [edi+ebx]
        jne     restart_loop
        sub     ebx, 4
        jz      last_bytes

        mov     eax, [esi+ebx]
        cmp     eax, [edi+ebx]
        jne     restart_loop

start_matched:
        sub     ebx, 4
        jz      last_bytes
        jmp     scan_dwords

align 16

less_than_dword:
        mov     ebx, eax
        sub     ebp, 2                  ; processing either 2 or 3 bytes
        shr     ebx, 16

align 16

@@:
        movzx   ecx, BYTE PTR [edi+ebp+2]
        cmp     ax, WORD PTR [edi]
        movzx   ecx, WORD PTR ShiftTable[ecx+ecx]    ; doesn't change flags
        je      matched_word

shift_word:
        add     edi, ecx
        cmp     edi, edx                ; check for end of data
        jle     @B
        jmp     no_match

align 16

matched_word:
        test    ebp, ebp
        jz      found
        cmp     bl, BYTE PTR [edi+2]
        je      found
        jmp     shift_word

align 16

last_bytes:
        mov     ebx, 0fffffffcH
        test    ebp, 3H                 ; are there any remainder bytes to test
        jz      found

        and     ebx, ebp
        mov     eax, [esi+ebx]
        mov     ebx, [edi+ebx]
        test    ebp, 2H
        jz      single_byte

        cmp     ax, bx
        jne     restart_loop
        test    ebp, 1H
        jz      found
        and     eax, 0ff0000H
        and     ebx, 0ff0000H
        sub     eax, ebx
        jne     restart_loop
        jmp     found

single_byte:
        sub     al, bl
        jne     restart_loop
    
align 16

found:
        pop     ebp
        mov     eax, edi
        sub     eax, ebp
@Ret:
        pop     ebx
        pop     edx                     ; return match_len in EDX
        pop     edi
        pop     esi
        ret                             ; return offset of string or -1 if not found

FJT3 endp

; ------------------------------------------------------------------------------

align 16

FJT4	proc

 comment    * -----------------------------------------------------------------------------
            BM by Cresta rewritten by IanB to use the same entry and exit protocols as
            BInStrWithLen, optimisations including the use of the .DATA? section for the
            ShiftTable, as the extra indexing is slower. Bugfix for less than 4 search
            chars. 4Gb string length searches possible with a 256-DWORD sized shift table.

            On entry:
                EAX = match_len (must be >= 2)
                ECX = lpMatch, pointer to test string
                EDX = DataLen
                EBP = lpData, pointer to source array
                EBX = StartPos offset in lpData
            On exit:
                EAX = string position (from start of source array) or -1 if not found
                EDX = match_len
            EBX/EBP/EDI/ESI are preserved.
            ----------------------------------------------------------------------------- *

        push    esi
        push    edi
        push    eax
        push    ebx
        push    ebp

        cmp     eax, 2                  ; string too short, must be > 1
        jb      no_match
        cmp     eax, MINUS_1            ; string too long, must be < 4Gb-1
        je      no_match

        add	    edx, ebp
        add     ebp, ebx                ; EBP = lpData (including startpos offset if any)
        lea     edi, ShiftTable
        mov     ebx, eax                ; EBX = match_len
        sub	    edx, eax
        add     eax, 1
        mov     esi, ecx                ; ESI = lpMatch
        add     edx, 1                  ; EDX = lpData+DataLen-match_len+1
        mov     ecx, 256
        rep     stosd                   ; fill 256-DWORD ShiftTable with match_len+1

        mov     edi, ebp                ; EDI = lpData + startpos
        mov     ebp, esi
        sub     eax, 1                  ; EAX = match_len

align 16

put_offset:
        movzx   ecx, BYTE PTR [ebp]
        add     ebp, 1
        mov     ShiftTable[ecx*4], eax
        sub     eax, 1
        jnz     put_offset

        mov     ebp, ebx                ; EBP = match_len
        mov     eax, [esi]              ; get first DWORD to compare
        cmp     ebx, 4
        jb      less_than_dword

align 16

first_dword:
        movzx   ecx, BYTE PTR [edi+ebp]
        and     ebx, 0fffffffcH         ; remove remainder bytes over DWORD count
        cmp     eax, [edi]
        mov     ecx, ShiftTable[ecx*4]  ; doesn't change flags
        je      start_matched
        jmp     do_shift

align 16

restart_loop:
        mov     eax, [esi]              ; get first DWORD to compare

do_shift:
        add     edi, ecx
        mov     ebx, ebp                ; restore match_len
        cmp     edi, edx                ; check for end of data
        jle     first_dword

no_match:
        or      eax, MINUS_1
        pop     ebp
        jmp     @Ret

align 16

scan_dwords:
        mov     eax, [esi+ebx]
        cmp     eax, [edi+ebx]
        jne     restart_loop
        sub     ebx, 4
        jz      last_bytes

        mov     eax, [esi+ebx]
        cmp     eax, [edi+ebx]
        jne     restart_loop
        sub     ebx, 4
        jz      last_bytes

        mov     eax, [esi+ebx]
        cmp     eax, [edi+ebx]
        jne     restart_loop
        sub     ebx, 4
        jz      last_bytes

        mov     eax, [esi+ebx]
        cmp     eax, [edi+ebx]
        jne     restart_loop

start_matched:
        sub     ebx, 4
        jz      last_bytes
        jmp     scan_dwords

align 16

less_than_dword:
        mov     ebx, eax
        sub     ebp, 2                  ; processing either 2 or 3 bytes
        shr     ebx, 16

align 16

@@:
        movzx   ecx, BYTE PTR [edi+ebp+2]
        cmp     ax, WORD PTR [edi]
        mov     ecx, ShiftTable[ecx*4]  ; doesn't change flags
        je      matched_word

shift_word:
        add     edi, ecx
        cmp     edi, edx                ; check for end of data
        jle     @B
        jmp     no_match

align 16

matched_word:
        test    ebp, ebp
        jz      found
        cmp     bl, BYTE PTR [edi+2]
        je      found
        jmp     shift_word

align 16

last_bytes:
        mov     ebx, 0fffffffcH
        test    ebp, 3H                 ; are there any remainder bytes to test
        jz      found

        and     ebx, ebp
        mov     eax, [esi+ebx]
        mov     ebx, [edi+ebx]
        test    ebp, 2H
        jz      single_byte

        cmp     ax, bx
        jne     restart_loop
        test    ebp, 1H
        jz      found
        and     eax, 0ff0000H
        and     ebx, 0ff0000H
        sub     eax, ebx
        jne     restart_loop
        jmp     found

single_byte:
        sub     al, bl
        jne     restart_loop
    
align 16

found:
        pop     ebp
        mov     eax, edi
        sub     eax, ebp
@Ret:
        pop     ebx
        pop     edx                     ; return match_len in EDX
        pop     edi
        pop     esi
        ret                             ; return offset of string or -1 if not found

FJT4 endp

; ------------------------------------------------------------------------------

OPTION PROLOGUE:PROLOGUEDEF 
OPTION EPILOGUE:EPILOGUEDEF

; ------------------------------------------------------------------------------

End	Start
